function ircServers()
{
	this.servers =				[];
	this.listAssistant =		false;

	this.cmSubscription = connectionmanager.watchStatus(this.cmHandler.bindAsEventListener(this)); 
}

ircServers.prototype.cmHandler = function(payload)
{

	if (payload.returnValue)
	{
		this.load();
	}
	connectionInfo = payload;
	return;
	
	// Needs a lot of testing
	if (!payload.returnValue)
	{
		this.newMessage('status', false, 'ip ' + this.ipAddress);
		if (this.ipAddress)
		{ 
			if (!this.ipMatches(payload.wifi) && !this.ipMatches(payload.wan))
			{
				if (payload.isInternetConnectionAvailable)
				{
					if (this.timerId)
					{
						this.reconnect = true;
						this.newMessage('status', false, 'disconnecting, but mark alternate connection' + this.dcThreshold);
					}
					else
					{
						this.reconnect = false;
						this.timerId = setTimeout(this.maybeReconnect.bind(this), this.dcThreshold);
						this.newMessage('status', false, 'reconnect after threshold ' + this.dcThreshold);
					}
					return;
				}
				else
				{
					// disconnect in 5 seconds if connection doesn't come back
					this.reconnect = false;
					this.newMessage('status', false, 'disconnect after threshold ' + this.dcThreshold);
					this.timerId = setTimeout(this.disconnect.bind(this), this.dcThreshold);
				}
				return;
			}

			if (this.timerId)
			{
				clearTimeout(this.timerId);
				this.timerId = false;
			}

			if (this.reconnectOnBetter)
			{
				if (this.ipDiffers(payload.wifi))
				{
					this.maybeReconnect();
				}
				else if (this.ipDiffers(payload.wan))
				{
					this.maybeReconnect(payload.wan.network);
				}
				return;
			}
		}
		else
		{
			if (payload.isInternetConnectionAvailable)
			{
				clearTimeout(this.timerId);
				this.timerId = false;
				this.newMessage('status', false, 'connected or connect... ' + this.connected);
				this.connected || this.connect();
			}
		}

		this.newMessage('status', false, '--- CM f ---');
	}
}

ircServers.prototype.setListAssistant = function(assistant)
{
	this.listAssistant = assistant;
}

ircServers.prototype.getListObjects = function()
{
	var returnArray = [];
	if (this.servers.length > 0)
	{
		for (var s = 0; s < this.servers.length; s++)
		{
			if (this.servers[s]) 
			{
				returnArray.push(this.servers[s].getListObject());
			}
		}
	}
	return returnArray;
}
ircServers.prototype.getServerArrayKey = function(id)
{
	if (this.servers.length > 0)
	{
		for (var s = 0; s < this.servers.length; s++)
		{
			if (this.servers[s].id == id)
			{
				return s;
			}
		}
	}
	return false;
}
ircServers.prototype.getServerForId = function(id)
{
	if (this.servers.length > 0)
	{
		for (var s = 0; s < this.servers.length; s++)
		{
			if (this.servers[s].id == id)
			{
				return this.servers[s];
			}
		}
	}
	return false;
}

ircServers.prototype.load = function()
{
	this.servers = [];
	db.getServers(this.loadResponse.bind(this));
}
ircServers.prototype.loadResponse = function(results)
{
	if (results.rows.length > 0)
	{
		for(var s = 0; s < results.rows.length; s++)
		{
			//alert('Loaded Server #' + results.rows.item(s)['id'] + ' - ' + results.rows.item(s)['alias']);
			var newServer = new ircServer(results.rows.item(s));
			this.servers.push(newServer);
		}
	}
	if (this.listAssistant)
	{
		this.listAssistant.updateList();
	}
}
ircServers.prototype.loadServer = function(id)
{
	db.getServer(id, this.loadServerResponse.bind(this));
}
ircServers.prototype.loadServerResponse = function(results)
{
	var newServer = new ircServer(results.rows.item(0));
	this.servers.push(newServer);
	
	if (this.listAssistant)
	{
		this.listAssistant.updateList();
	}
}

ircServers.prototype.newServer = function(params, assistant)
{
	db.saveServer(params, this.newServerResponse.bind(this, assistant));
}
ircServers.prototype.newServerResponse = function(assistant, results)
{
	assistant.doneSaving();
	this.loadServer(results.insertId);
}

ircServers.prototype.deleteServer = function(id)
{
	var key = this.getServerArrayKey(id);
	
	if (this.servers[key].connected)
	{
		this.servers[key].disconnect();
	}
	
	db.deleteServer(id, this.deleteServerResponse.bind(this, key));
}
ircServers.prototype.deleteServerResponse = function(key, results)
{
	this.servers[key] = false;
}
